import { HttpHeaders } from '@angular/common/http';
import { Observable } from 'rxjs';
import { JsonApiDatastore } from '../services/json-api-datastore.service';
import { ModelConfig } from '../interfaces/model-config.interface';
export declare class JsonApiModel {
    private internalDatastore;
    id: string;
    modelInitialization: boolean;
    [key: string]: any;
    lastSyncModels: Array<any>;
    constructor(internalDatastore: JsonApiDatastore, data?: any);
    isModelInitialization(): boolean;
    syncRelationships(modelData: any, included: any, remainingModels?: Array<any>): void;
    save(params?: any, headers?: HttpHeaders, customUrl?: string): Observable<this>;
    get hasDirtyAttributes(): boolean;
    private checkChanges;
    rollbackAttributes(): void;
    get modelConfig(): ModelConfig;
    private parseHasMany;
    private parseBelongsTo;
    private getHasManyRelationship;
    private getBelongsToRelationship;
    private createOrPeek;
}
//# sourceMappingURL=json-api.model.d.ts.map